【题目描述】给定2-3颗树,每个边的边权为1,解决以下独立的问题。

    现在通过连接若干遍使得图为连通图,并且Σdis(x,y)最大,x,y只算一次。

    每个点为黑点或者白点,现在需要删除一些边,使得图中的黑点度数为奇数,白点为偶数,要求删除的边最多。

  【数据范围】 100% n<=10^5

  首先我们来解决第一问,因为每加一条边就可能使得若干点到其他点的距离变小,那么我们需要加尽量少的边来使得图连通。

  设dis_[x]为x在x所在子树中,x到其他所有点的距离,这个我们可以通过设dis[x]表示x到x子树中所有点的距离和来由父节点转移得到。

  那么答案可以分为两部分,分别为树中的点对距离和跨树的点对距离,前一个问题比较容易,可以通过dis_[x]或者计算每条边被经过的次数来求出。

  那么对于两颗树的情况,我们就需要连接这两棵树中dis值最大的两个点,假设为x,y。这样答案就是      dis[x]*size[tree_y]+dis[y]*size[tree_x]+size[tree_x]*size[tree_y],这个由连接的那条边的被经过次数可以得出。

  那么现在考虑三棵树的情况,我们需要枚举中间的树,这样左右两棵树肯定连接dis最大的点,中间的连接的则不确定,我们可以列出来整个答案的表达式,设左面的树和中间的树通过x,y点连通,中间的点和右面的树通过u,v点连接,设三棵树的size为size[1],size[2],size[3],y与u点的距离为d[y][u],那么答案就是size[1]*dis_[y]+size[2]*dis_[x]+size[1]*size[2]+size[3]*dis_[u]+size[2]*dis_[v]+size[1]*dis_[v]+size[3]*dis_[u]+size[1]*size[3]*(d[y][u]+2)

  我们可以发现,这个中与y,u点有关的式子可以写成a*dis_[y]+b*dis_[u]+c*d[u][v]的形式,其中a,b,c为常数,那么对于这个我们就可以用tree-dp搞出来,记录点x的子树中dis_[p]+(d[x][p]+1)*c的最大值,然后不断的更新答案就可以了。

  第二问比较简单,我们可以贪心的来想,对于一棵树,我们从叶子节点开始,因为叶子节点的度数为1,那么我们只需要判断叶子节点的颜色,就可以判断这个点和其父节点的边是否可以删掉。

  反思:开始写tree-dp维护中间树的值的时候没有考虑到一些特殊情况,比如连接的y,u点其中一点是另一点的祖先,还有开始觉得如果中间的树选择两个点肯定不能是同一点,所以边界就处理的不是特别好,但是可能会有某些点单独构成树,这样的话就必须连接同一个点。第二问还是比较容易写的。

//By BLADEVIL
#include <cstdio>
#include <cstring>
#include <algorithm>
#define maxn 100010
#define LL long long using namespace std; LL n,m,l;
LL a[maxn],pre[maxn<<],other[maxn<<],last[maxn],col[maxn],rot[],num[maxn<<],flag[maxn];
LL dis_[maxn],dis[maxn],size[maxn],ans[maxn],ANS[],max_a[maxn],max_b[maxn],cnt[maxn]; void connect(LL x,LL y,LL z) {
pre[++l]=last[x];
last[x]=l;
other[l]=y;
num[l]=z;
} void paint(LL x,LL fa,LL c) {
col[x]=c;
for (LL p=last[x];p;p=pre[p]) {
if (other[p]==fa) continue;
paint(other[p],x,c);
}
} void make_dis(LL x,LL fa) {
dis[x]=; size[x]=;
for (LL p=last[x];p;p=pre[p]) {
if (other[p]==fa) continue;
make_dis(other[p],x);
dis[x]+=dis[other[p]]+size[other[p]];
size[x]+=size[other[p]];
}
} void make_dis_(LL x,LL fa,LL s) {
if (fa!=-) dis_[x]=dis_[fa]-size[x]-dis[x]+s-size[x]+dis[x]; else dis_[x]=dis[x];
for (LL p=last[x];p;p=pre[p]) {
if (other[p]==fa) continue;
make_dis_(other[p],x,s);
}
} void calc(LL x,LL fa,LL s) {
for (LL p=last[x];p;p=pre[p]) {
if (other[p]==fa) continue;
ANS[col[x]]+=size[other[p]]*(s-size[other[p]]);
calc(other[p],x,s);
}
} void dp(LL x,LL fa,LL a,LL b,LL c,LL &Ans) {
max_a[x]=dis_[x]*a+c; max_b[x]=dis_[x]*b+c;
for (LL p=last[x];p;p=pre[p]) {
if (other[p]==fa) continue;
dp(other[p],x,a,b,c,Ans);
max_a[x]=max(max_a[x],max_a[other[p]]+c);
max_b[x]=max(max_b[x],max_b[other[p]]+c);
}
LL aa=,bb=;
//printf("%d %d\n",max_a[x],max_b[x]);
for (LL p=last[x];p;p=pre[p]) {
if (other[p]==fa) continue;
Ans=max(Ans,max_a[x]+c+dis_[x]*b);
Ans=max(Ans,max_b[x]+c+dis_[x]*a);
}
//printf("%d %d\n",x,Ans);
for (LL p=last[x];p;p=pre[p]) {
if (other[p]==fa) continue;
if (max_a[other[p]]>max_a[aa]) aa=other[p];
if (max_b[other[p]]>max_b[bb]) bb=other[p];
}
//printf("%d %d\n",x,Ans);
for (LL p=last[x];p;p=pre[p]) {
if (other[p]==fa) continue;
if (other[p]!=aa) Ans=max(Ans,max_a[aa]+max_b[other[p]]+(c<<));
//printf("%d %d %d %d\n",Ans,max_a[aa],max_b[other[p]],c<<1);
if (other[p]!=bb) Ans=max(Ans,max_b[bb]+max_a[other[p]]+(c<<));
}
//printf("%d %d\n",aa,max_a[aa]);
//printf("%d %d\n",x,Ans);
} LL work(LL le,LL x,LL ri) {
LL a=size[le],b=size[ri],c=size[le]*size[ri],ans=;
LL cur[]; cur[]=cur[]=cur[]=;
for (LL i=;i<=n;i++) cur[col[i]]=max(cur[col[i]],dis_[i]);
//printf("fuck %d %d\n",col[le],col[ri]);
ans=cur[col[le]]*size[x]+a*size[x]+cur[col[ri]]*size[x]+size[x]*b+a*cur[col[ri]]+b*cur[col[le]];
//printf("fuck\n");
memset(max_a,,sizeof max_a);
memset(max_b,,sizeof max_b);
LL Ans=-;
dp(x,-,a,b,c,Ans);
Ans=max(Ans,c<<);
//printf("%d %d\n",ans,Ans);
ans+=Ans;
//printf("%d\n",ans);
return ans;
} void Work(LL x,LL fa) {
for (LL p=last[x];p;p=pre[p]) {
if (other[p]==fa) continue;
Work(other[p],x);
}
//printf("%d %d %d\n",x,a[x],cnt[x]);
if (a[x]^cnt[x]) {
for (LL p=last[x];p;p=pre[p])
if (other[p]==fa) flag[num[p]]=;
cnt[fa]^=;
};
} int main() {
freopen("lct.in","r",stdin); freopen("lct.out","w",stdout);
scanf("%lld%lld\n",&n,&m);
char c;
for (LL i=;i<=n;i++) scanf("%c",&c),a[i]=(c=='B')?:;
for (LL i=;i<=m;i++) {
LL x,y;
scanf("%lld%lld",&x,&y);
connect(x,y,i); connect(y,x,i);
}
LL sum=;
for (LL i=;i<=n;i++) if (!col[i]) paint(i,-,++sum),rot[sum]=i;
for (LL i=;i<=;i++) if (rot[i]) make_dis(rot[i],-),make_dis_(rot[i],-,size[rot[i]]);
for (LL i=;i<=;i++) if (rot[i]) calc(rot[i],-,size[rot[i]]);
//for (LL i=1;i<=n;i++) printf("%d ",col[i]); printf("\n");
//printf("%d %d %d\n",rot[1],rot[2],rot[3]);
//for (LL i=1;i<=n;i++) printf("%d %d %d %d\n",i,dis[i],dis_[i],size[i]);
//for (LL i=1;i<=3;i++) printf("%d ",ANS[i]); printf("\n");
if (sum==) {
LL cur[];
cur[]=cur[]=;
for (LL i=;i<=n;i++) cur[col[i]]=max(cur[col[i]],dis_[i]);
LL Ans=ANS[]+ANS[]+cur[]*size[rot[]]+cur[]*size[rot[]]+size[rot[]]*size[rot[]];
printf("%lld\n",Ans);
//printf("%d %d\n",cur[1],cur[2]);
//printf("%d %d\n",size[rot[1]],size[rot[2]]);
//printf("%d %d\n",ANS[1],ANS[2]);
} else {
LL Ans=;
Ans=max(Ans,work(rot[],rot[],rot[]));
Ans=max(Ans,work(rot[],rot[],rot[]));
Ans=max(Ans,work(rot[],rot[],rot[]));
//printf("%d\n",Ans);
Ans+=ANS[]+ANS[]+ANS[];
printf("%lld\n",Ans);
}
for (LL i=;i<=n;i++)
for (LL p=last[i];p;p=pre[p]) cnt[other[p]]++,cnt[i]++;
//for (LL i=1;i<=n;i++) printf("%d\n",cnt[i]);
//for (LL i=1;i<=n;i++) printf("%d\n",a[i]);
for (LL i=;i<=n;i++) cnt[i]/=,cnt[i]%=;
for (LL i=;i<=;i++) Work(rot[i],-);
LL ans_=;
for (LL i=;i<=m;i++) if (!flag[i]) ans_++;
printf("%lld\n",ans_);
for (LL i=;i<=m;i++) if (!flag[i]) printf("%lld ",i); printf("\n");
fclose(stdin); fclose(stdout);
return ;
}

【HNOI】 lct tree-dp的更多相关文章

  1. 【BZOJ】2631: tree LCT

    [题意]给定n个点的树,每个点初始权值为1,m次操作:1.x到y的点加值,2.断一条边并连一条边,保证仍是树,3.x到y的点乘值,4.x到y的点权值和取模.n,m<=10^5. [算法]Link ...

  2. 【BZOJ2212】[Poi2011]Tree Rotations 线段树合并

    [BZOJ2212][Poi2011]Tree Rotations Description Byteasar the gardener is growing a rare tree called Ro ...

  3. 【题解】Digit Tree

    [题解]Digit Tree CodeForces - 716E 呵呵以为是数据结构题然后是淀粉质还行... 题目就是给你一颗有边权的树,问你有多少路径,把路径上的数字顺次写出来,是\(m\)的倍数. ...

  4. 【题解】POJ1934 Trip (DP+记录方案)

    [题解]POJ1934 Trip (DP+记录方案) 题意: 传送门 刚开始我是这么设状态的(谁叫我DP没学好) \(dp(i,j)\)表示钦定选择\(i\)和\(j\)的LCS,然而你会发现这样钦定 ...

  5. 【题解】[P4178 Tree]

    [题解]P4178 Tree 一道点分治模板好题 不知道是不是我见到的题目太少了,为什么这种题目都是暴力开值域的桶QAQ?? 问点对,考虑点分治吧.直接用值域树状数组开下来,统计的时候直接往树状数组里 ...

  6. 【HNOI】合唱队

    [HNOI]合唱队 题意 对于一个初始序列,保证两两不同,通过一些变换得到目标序列: 第一个值直接插入空的当前队列 对于从第二个值开始的每个值 如果原序列中 $ a[i] $,若 $ a[i]> ...

  7. 【题解】剪纸条(dp)

    [题解]剪纸条(dp) HRBUST - 1828 网上搜不到题解?那我就来写一篇吧哈哈哈 最优化问题先考虑\(dp\),设\(dp(i)\)表示将前\(i\)个字符(包括\(i\))分割成不相交的回 ...

  8. 【题解】地精部落(DP)

    [题解]地精部落(DP) 设\(f_i\)表示强制第一个是谷的合法方案数 转移枚举一个排列的最大值在哪里,就把序列分成了互不相干的两个部分,把其中\(i-1\choose j-1\)的数字分配给前面部 ...

  9. 【总结】Link-Cut Tree

    这是一篇关于LCT的总结 加删边的好朋友--Link Cut Tree Link-Cut Tree,LCT的全称 可以说是从树剖引出的问题 树剖可以解决静态的修改或查询树的链上信息:那如果图会不断改变 ...

随机推荐

  1. CURL & Fetch

    CURL & Fetch https://kigiri.github.io/fetch/ https://stackoverflow.com/questions/31039629/conver ...

  2. DELPHI enablecontrols,disablecontrols函数

    DisableControls方法是在程序修改或后台有刷新记录的时候切断数据组件,如TTABLE.ADOQUERY等等与组件数据源的联系.如果没有切断,数据源中只要一有数据的改动,尤其是批量改动的话, ...

  3. ASP.NET MVC4中使用bootstrip模态框时弹不出的问题

    最近发现使用在MVC中使用bootstrip的模态框时弹不出来,但单独建立一HTML文件时可以弹出,说明代码没有问题,经过多次测试发现,在MVC的cshtml文件中添加上以下语句就能正常 @{ Lay ...

  4. Django错误 OperationalError: no such column: xxx

    模型前后操作如下: 第一次迁移: class Snippet(models.Model): created = models.DateTimeField(auto_now_add=True) titl ...

  5. 锁-lock,信号量4

    1. 全局解释器锁,保证同一时间只有一个线程在执行,但是由于它是把数据copy成了两份,所以 只有全局解释器锁的时候,数据加减照样出错了. 2.用户态的锁,保证同一时间,只有一个线程在真真正正地修改数 ...

  6. 洛谷3258:[USACO2012 MAR]Flowerpot 花盆——题解

    https://www.luogu.org/problemnew/show/P2698#sub 老板需要你帮忙浇花.给出N滴水的坐标,y表示水滴的高度,x表示它下落到x轴的位置. 每滴水以每秒1个单位 ...

  7. 欢迎大家收听喜马拉雅,我的主播频道http://m.ximalaya.com/weizhubo/44966139

    关注光荣之路软件技术培训账号,即时收取测试开发技术的免费公开课信息,各大公司测试及开发招聘信息.最新的技术咨询.线下测试 喜马拉雅微电台,每天早晨光荣之路创始人吴老,都会跟大家一起分享测试行业心得体会 ...

  8. BZOJ2823 [AHOI2012]信号塔 【最小圆覆盖】

    题目链接 BZOJ2823 题解 最小圆覆盖模板 都懒得再写一次 #include<iostream> #include<cstdio> #include<cmath&g ...

  9. webpack散记

    1. manifest manifest存储了webpack的chunk相关的信息.具体为一个对象,或者包含runtime的一段代码.其中包含着一个chunkId,已经对应chunkId的相关信息,例 ...

  10. LibreOJ #6220. sum(数论+构造)

    题目大意:在数组中找出一些数,使它们的和能被n整除 这题标签是数学,那我就标题就写数论好了... 显然如果数组中有n的倍数直接取就行. 那假设数组中没有n的倍数,把数组中的数求前缀和后全部%n,会得到 ...